clear all;
clc;

%% Load contours of iso-loudness
[spl, freq] = iso226(80);   % ISO-266 Standard
fbins = freq(1:2:end);      % Frequency bins [Hz]
fbins(1) = [];              % Eliminate one low-frequency bin below audio range
wbins = fbins*2*pi;         % Frequency bins [rad/sec]
mags = 10.^-(spl(1:2:end)/20);  % Passband magnitudes (linear Scale)
mags = mags/min(mags);      % normalized passband magnitude

%% Filter Design
% Assignment: define H(i,i) for i from 1 to 15.  These transfer functions should:
%   (a) have bassband magnitude equal to mags(i) for the ith filter
%   (b) The passband of the filter should be:
%       i==1: from 0 Hz to fbins(1)=32 Hz
%       1<i<=15: from fbins(i-1) to fbins(i)
%       i==15: from fbins(15)=12.5 kHz to infinity
%   (c) Have 40 dB/dec attenuation in the stopbands
%   (d) Have zero ripple in the passband
% The code below is a template, but will need to be replaced with your own,
% except for the final two lines (generateAudioVisualization(...))

s = tf('s');
H(1,1) = mags(1)/(1+s/wbins(1));        % Filter for frequencies below fbins(1) = 32 Hz
% H(2,2) = ...                          % Filter for 32 Hz < f < 50 Hz
% H(3,3) = ...                          % Filter for 50 Hz < f < 80 Hz   
%   ...
%   ...
H(15,15) = mags(15)/(1+wbins(15)/s);    % Filter for f > 12.5 kHz

%% Process and play
generateAudioVisualization('chirp.wav', H, fbins);
% generateAudioVisualization('Tennessee__Rocky_Top__singing.mp3', H, fbins);